%Script to study the function f in the infinite range limit
clc; clear all; close all;

%The function is f(x; q) = q*tanh(4x^2)


%###########################################################################################
%The critical x and q at which the function is tangent to y = x are found
%by finding the zeros of the following equation
F = inline('(x/tanh(4*x^2) - x*tanh(4*x^2))*x - 1/8');
xc = fzero(F, 0.8);
qc = xc/tanh(4*xc^2);
%Result: xc = 0.521694233359602; qc = 0.655075164673951;

%###########################################################################################
%Find fixed points for a given q
q = 0.8
F = @(x) q*tanh(4*x^2)-x;
xfp = fzero(F, 1)
pause

%###########################################################################################
%Some approximate data (roughly taken from some image in the literature) for the DK boundary
p1c = [414,   447, 473.5, 504.0, 533.0, 562.0, 582, 606, 626.0, 651, 669.5]/828.5;
p2c = [676.5, 671, 658.5, 629.5, 592.0, 536.5, 478, 393, 296.5, 147, 2]/676.5;

%Plot the trajectory of this parametrization in the p1 p2 plane
figure(1);
plot(p1c, p2c, 'g-o'); hold on;
xlim([0,1]); ylim([0,1]);

for q = 0.8    
    figure(1);
    scatter(myfun(0.5, q), myfun(1, q), 'r');
end


%###########################################################################################
%Plot the function f, the y = x line, and the "RG flow"
q = 0.8;
x = linspace(0,1);
figure(2);
plot([0,1], [0,1], 'k--'); hold on;
xlim([0,1]); ylim([0,1]);

for q = 0.7:0.05:1
    y = myfun(x, q);
    plot(x, y, 'r');
end

% for x = [0.3, 0.9]; %Starting x
%     xflow = []; %Initialization of the variables contaiining the segments of the "RG flow"
%     yflow = [];
% 
%     for n = 1:14;
%         xflow(end+1) = x;
%         yflow(end+1) = x;
%         y = myfun(x, q);
%         xflow(end+1) = x;
%         yflow(end+1) = y;
%         x = y;
%     end
% 
%     plot(xflow, yflow, 'b--')
% end
%% FUNCTIONS
function f = myfun(x, q)
    f = q*tanh(4*x.^2);
end